## drbd-doc 8.4~20220106

=== Makefile ===
# you can override on command line
lang = en

define run-in-docker =
	docker run --rm -v $$(pwd):/home/makedoc/linbit-documentation linbit-documentation /bin/sh -c 'cd ~/linbit-documentation && make $(patsubst %-docker,%,$@) lang=$(lang)'
endef

.PHONY: README.html-docker
README.html: README.adoc
	asciidoctor -n -o $@ $<

README.html-docker: dockerimage
	$(run-in-docker)

#
# po4a v0.54 is required to make build ja adoc files.
#
define dockerfile=
FROM debian:buster
MAINTAINER Roland Kammerer <roland.kammerer@linbit.com>
ADD /GNUmakefile /linbit-documentation/GNUmakefile
RUN groupadd --gid $(shell id -g) makedoc
RUN useradd -m -u $(shell id -u) -g $(shell id -g) makedoc
RUN apt-get update && apt-get install -y make inkscape ruby po4a patch openssh-client lftp curl unzip
RUN gem install --pre asciidoctor-pdf
RUN gem install --pre asciidoctor-pdf-cjk
RUN gem install asciidoctor-pdf-cjk-kai_gen_gothic && asciidoctor-pdf-cjk-kai_gen_gothic-install
RUN curl https://packages.linbit.com/public/genshingothic-20150607.zip > /tmp/ja.zip && (mkdir /linbit-documentation/genshingothic-fonts && cd /linbit-documentation/genshingothic-fonts && unzip /tmp/ja.zip); rm /tmp/ja.zip
USER makedoc
RUN mkdir /home/makedoc/.ssh && chmod 700 /home/makedoc/.ssh && ssh-keygen -f /home/makedoc/.ssh/id_rsa -t rsa -N '' && cat /home/makedoc/.ssh/id_rsa.pub
endef

export dockerfile
Dockerfile:
	@echo "$$dockerfile" > $@

.PHONY: dockerimage
dockerimage: Dockerfile
	if ! docker images --format={{.Repository}}:{{.Tag}} | grep -q 'linbit-documentation:latest'; then \
		test -f GNUmakefile || echo 'include Makefile' > GNUmakefile ; \
		docker build -t linbit-documentation . ; \
	fi

# UG 9
.PHONY: UG9-pdf-finalize UG9-pdf-finalize-docker UG9-html-finalize UG9-html-finalize-docker UG9-pot UG9-pot-docker
UG9-pdf-finalize:
	make -C UG9 pdf-finalize lang=$(lang)

UG9-pdf-finalize-docker: dockerimage
	$(run-in-docker)

UG9-html-finalize:
	make -C UG9 html-finalize lang=$(lang)

UG9-html-finalize-docker: dockerimage
	$(run-in-docker)

UG9-pot:
	make -C UG9 pot lang=en

UG9-pot-docker: dockerimage
	$(run-in-docker)

# UG 8.4
.PHONY: UG8.4-pdf-finalize UG8.4-pdf-finalize-docker UG8.4-html-finalize UG8.4-html-finalize-docker UG8.4-pot UG8.4-pot-docker
UG8.4-pdf-finalize:
	make -C UG8.4 pdf-finalize lang=$(lang)

UG8.4-pdf-finalize-docker: dockerimage
	$(run-in-docker)

UG8.4-html-finalize:
	make -C UG8.4 html-finalize lang=$(lang)

UG8.4-html-finalize-docker: dockerimage
	$(run-in-docker)

UG8.4-pot:
	make -C UG8.4 pot lang=en

UG8.4-pot-docker: dockerimage
	$(run-in-docker)

## targets you can only use if you cloned the according *private* project
# tech guides
.PHONY: tech-guides-pdf-finalize tech-guides-pdf-finalize-docker
tech-guides-pdf-finalize:
	make -C tech-guides pdf-finalize

tech-guides-pdf-finalize-docker: dockerimage
	$(run-in-docker)

.PHONY: clean clean-all
clean:
	$(warning this target is reserved, maybe you look for clean-all)

clean-all:
	make -C UG8.4 clean-all
	make -C UG9 clean-all

=== UG8.4/Makefile ===
include ../UG-top.mk

=== man-pages/Makefile ===
OUTDIR=output

OUTDIRPDF=$(OUTDIR)-pdf
OUTDIRHTML=$(OUTDIR)-html

OUTDIRPDFFINAL=$(OUTDIRPDF)-finalize
OUTDIRHTMLFINAL=$(OUTDIRHTML)-finalize

ifeq ($(DRBD_UTILS),)
$(error "point DRBD_UTILS to a compiled checkout INCLUDING GENERATED man pages of drbd-utils")
else
MANDIR=$(DRBD_UTILS)/documentation
endif

ifneq ($(lang),en)
DRBD_UTILS_LANG=$(lang)
endif

ifeq ($(lang),)
MAN_LANG=en
else
MAN_LANG=$(lang)
endif

MANDIR_v9=$(MANDIR)/$(DRBD_UTILS_LANG)/v9
MANDIR_v84=$(MANDIR)/$(DRBD_UTILS_LANG)/v84

MANPAGES_v9_5=$(wildcard $(MANDIR_v9)/*.5)
MANPAGES_v9_7=$(wildcard $(MANDIR_v9)/*.7)
MANPAGES_v9_8=$(wildcard $(MANDIR_v9)/*.8)
MANPAGES_v9=$(MANPAGES_v9_5) $(MANPAGES_v9_7) $(MANPAGES_v9_8)

MANPAGES_v84_5=$(wildcard $(MANDIR_v84)/*.5)
MANPAGES_v84_8=$(wildcard $(MANDIR_v84)/*.8)
MANPAGES_v84=$(MANPAGES_v84_5) $(MANPAGES_v84_8)

OUTMANS_v9_5=$(patsubst $(MANDIR_v9)/%.5,$(OUTDIRHTML)/v9/%.5.html, $(MANPAGES_v9_5))
OUTMANS_v9_7=$(patsubst $(MANDIR_v9)/%.7,$(OUTDIRHTML)/v9/%.7.html, $(MANPAGES_v9_7))
OUTMANS_v9_8=$(patsubst $(MANDIR_v9)/%.8,$(OUTDIRHTML)/v9/%.8.html, $(MANPAGES_v9_8))

OUTMANS_v84_5=$(patsubst $(MANDIR_v84)/%.5,$(OUTDIRHTML)/v84/%.5.html, $(MANPAGES_v84_5))
OUTMANS_v84_8=$(patsubst $(MANDIR_v84)/%.8,$(OUTDIRHTML)/v84/%.8.html, $(MANPAGES_v84_8))

OUTMANS=$(OUTMANS_v9_5) $(OUTMANS_v9_7) $(OUTMANS_v9_8) $(OUTMANS_v84_5) $(OUTMANS_v84_8)

define run-mandoc =
	cat $< | mandoc -Thtml -Ostyle=mandoc.css 1> $@
	mps=""; \
	echo $@ | grep -q 84 && mps="$(MANPAGES_v84)" || mps="$(MANPAGES_v9)"; \
	for mp in $$mps; do \
		last=$$(echo -n $$mp | tail -c 1); \
		bn=$$(basename $$(basename $$(basename $$mp .5) .8) .7); \
		sed -i "s/<b>$$bn<\/b>/<b><a href=\"$$bn.$$last.html\">$$bn<\/a><\/b>/g" $@; \
	done;
endef

$(OUTDIRHTML)/v9/%.5.html: $(MANDIR_v9)/%.5
	$(run-mandoc)

$(OUTDIRHTML)/v9/%.7.html: $(MANDIR_v9)/%.7
	$(run-mandoc)

$(OUTDIRHTML)/v9/%.8.html: $(MANDIR_v9)/%.8
	$(run-mandoc)

$(OUTDIRHTML)/v84/%.5.html: $(MANDIR_v84)/%.5
	$(run-mandoc)

$(OUTDIRHTML)/v84/%.8.html: $(MANDIR_v84)/%.8
	$(run-mandoc)

define run-index =
	mps=""; \
	desc=""; \
	echo $@ | grep -q v84; \
	if [ "$$?" =  "1" ]; then \
		mps="$(MANPAGES_v9)"; desc="9.0"; \
	else \
		mps="$(MANPAGES_v84)"; desc="8.4"; \
	fi; \
	echo "<html>" > $@; \
	echo "<head>" >> $@; \
	echo '<link rel="stylesheet" href="mandoc.css" type="text/css" media="all"/>' >> $@; \
	echo "</head>" >> $@; \
	echo "<h1>DRBD $${desc} Manual Pages</h1>" >> $@; \
	for mp in $$mps; do \
		bn=$$(basename $$mp); \
		echo "<a href=$${bn}.html>$$bn</a>" >> $@; \
	done; \
	echo "</html>" >> $@
endef

.PHONY: $(OUTDIRHTML)/v84/index.html
$(OUTDIRHTML)/v84/index.html:
	$(run-index)

.PHONY: $(OUTDIRHTML)/v9/index.html
$(OUTDIRHTML)/v9/index.html:
	$(run-index)

.PHONY: dirs
dirs:
	mkdir -p $(OUTDIRHTML)/v84/ || true
	mkdir -p $(OUTDIRHTML)/v9/ || true

.PHONY: style
style: dirs
	# brr, nasty hack
	cp -f mandoc.css $(OUTDIRHTML)/v84/
	cp -f mandoc.css $(OUTDIRHTML)/v9/

html: style $(OUTMANS) $(OUTDIRHTML)/v84/index.html $(OUTDIRHTML)/v9/index.html
	@echo "Generated web page in $$(pwd)/$(OUTDIRHTML)"
	@echo "execute 'make html-finalize' to prepare upload"

html-finalize: html
	rm -rf $(OUTDIRHTMLFINAL) && mkdir $(OUTDIRHTMLFINAL) && touch $(OUTDIRHTMLFINAL)/.empty
	for d in v84 v9; do \
		case "$$d" in \
			v84) fn=8.4;; \
			v9) fn=9.0;; \
		esac; \
		(cd $(OUTDIRHTML)/$$d; zip ../../$(OUTDIRHTMLFINAL)/man-pages-$(MAN_LANG)-$${fn}.zip ./*.html);\
	done

pdf:
	$(error "pdf generation is not supported")

pdf-finalize: pdf

clean:
	rm -rf $(OUTDIRHTML)/* $(OUTDIRHTMLFINAL)/*

=== UG8.4/cn/Makefile ===
lang=cn

include ../../UG-build-adoc.mk
include ../../UG-build.mk

=== UG8.4/en/Makefile ===
lang=en

include ../../UG-build-adoc.mk
include ../../UG-build.mk

=== UG8.4/ja/Makefile ===
lang=ja
ASCIIDOCTOR_ADD_OPTIONS=-r asciidoctor-pdf-cjk
FONTDIR=../../genshingothic-fonts

include ../../UG-build-po.mk
include ../../UG-build.mk

=== UG9/cn/Makefile ===
lang=cn
ASCIIDOCTOR_ADD_OPTIONS=-r asciidoctor-pdf-cjk -r asciidoctor-pdf-cjk-kai_gen_gothic -a pdf-style=KaiGenGothicCN -a pdf-style=default-theme.yml --trace

include ../../UG-build-po.mk
include ../../UG-build.mk

=== UG9/en/Makefile ===
include ../../UG-build-adoc.mk
include ../../UG-build.mk

## drbd-doc 8.4~20140825

=== debian/changelog ===
drbd-doc (8.4~20140825-1) unstable; urgency=medium

  * Import upstream changes, up to commit ac7bd5612ec2 (25/08/2014)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 18 Sep 2014 10:13:29 +0300

drbd-doc (8.4~20130416-1) unstable; urgency=low

  * Initial release (Closes: #531018, #753880)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Sat, 05 Jul 2014 03:04:16 +0300

=== debian/control ===
Source: drbd-doc
Section: doc
Priority: extra
Maintainer: Debian DRBD Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends: debhelper (>= 9), automake, asciidoc, fop,
 libgtkmathview-bin, inkscape, xsltproc, docbook-xsl,
 dh-autoreconf, docbook-xml
Standards-Version: 3.9.5
Homepage: http://www.drbd.org
Vcs-Git: git://anonscm.debian.org/debian-ha/drbd-doc/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-ha/drbd-doc.git

Package: drbd-doc
Architecture: all
Depends: ${misc:Depends}
Description: RAID 1 over TCP/IP for Linux (user documentation)
 Drbd is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in
 nodes synchronised using TCP/IP. This simulates RAID 1 but avoiding
 the use of uncommon hardware (shared SCSI buses or Fibre Channel).
 It is currently limited to fail-over HA clusters.
 .
 This package contains the DRBD User's Guide in HTML and PDF format.

## drbd-doc 8.4~20151102

=== debian/changelog ===
drbd-doc (8.4~20151102-1) unstable; urgency=medium

  * Import upstream changes up to commit 0d6393f.
  * B-D on default-jre to fix FTBFS with OpenJDK 8.
  * Bump standards to 3.9.7; no changes needed.
  * d/control: use HTTPS in Vcs-* fields.
  * d/copyright: bump debian/ copyright years.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Tue, 15 Mar 2016 19:56:49 +0200

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,11 @@
 Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
 Build-Depends: debhelper (>= 9), automake, asciidoc, fop,
  libgtkmathview-bin, inkscape, xsltproc, docbook-xsl,
- dh-autoreconf, docbook-xml
-Standards-Version: 3.9.5
+ dh-autoreconf, docbook-xml, default-jre
+Standards-Version: 3.9.7
 Homepage: http://www.drbd.org
-Vcs-Git: git://anonscm.debian.org/debian-ha/drbd-doc/
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-ha/drbd-doc.git
+Vcs-Git: https://anonscm.debian.org/git/debian-ha/drbd-doc.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=debian-ha/drbd-doc.git
 
 Package: drbd-doc
 Architecture: all

## drbd-doc 8.4~20220106

=== debian/changelog ===
drbd-doc (8.4~20220106-1) unstable; urgency=medium

  * Switch Vcs-* URLs to salsa.d.o
  * Switch to new upstream documentation from
    https://github.com/LINBIT/linbit-documentation
    - Remove makedoc
    - Drop all patches
    - Remove obsolete d/README.packaging
    + Adjust build-dependencies.
      The new documentation system requires only asciidoctor(-pdf) and
      inkscape. (Closes: #993661)
    + d/rules: adjust to the new build system
    + Adjust Source and Upstream-Name in d/copyright
    + dh_install: pick the right artifacts for installation
  * Bump DH compat to 13; no changes needed
  * d/copyright: adjust years, drop makedoc reference
  * Bump Standards-Version to 4.6.0.
    + Replace Priority: extra with optional
  * d/copyright: remove tabs
  * Strip remote fonts from the HTML stylesheet

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 31 Jan 2022 13:09:06 +0200

=== debian/control ===
Source: drbd-doc
Section: doc
Priority: optional
Maintainer: Debian DRBD Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends: debhelper-compat (= 13), dh-exec,
 asciidoctor, ruby-asciidoctor-pdf, inkscape, zip
Standards-Version: 4.6.0
Homepage: http://www.drbd.org
Vcs-Git: https://salsa.debian.org/ha-team/drbd-doc.git
Vcs-Browser: https://salsa.debian.org/ha-team/drbd-doc

Package: drbd-doc
Architecture: all
Depends: ${misc:Depends}, fonts-font-awesome
Description: RAID 1 over TCP/IP for Linux (user documentation)
 Drbd is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in
 nodes synchronised using TCP/IP. This simulates RAID 1 but avoiding
 the use of uncommon hardware (shared SCSI buses or Fibre Channel).
 It is currently limited to fail-over HA clusters.
 .
 This package contains the DRBD User's Guide in HTML and PDF format.

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1

UG_HTML = "UG8.4/en/output-html/drbd-users-guide-without-css.html"

%:
	dh $@

override_dh_auto_build:
	$(MAKE) -C UG8.4 html-finalize pdf
	sed -i -e '\#<link rel="stylesheet" href="https://fonts.googleapis.com.*#d' $(UG_HTML)
	sed -i -e 's#href="http.*font-awesome\.min\.css#href="file:///usr/share/fonts-font-awesome/css/font-awesome.min.css"#' $(UG_HTML)

override_dh_auto_clean:
	$(MAKE) -C UG8.4 clean

.PHONY: override_dh_auto_build override_dh_auto_clean
